#include "includes.hpp"

stack::stack(int size,int amount) {
    this->zone=(void *)malloc(size*amount);
	this->pointer=-1;
	this->amount=amount;
	this->size=size;
}

stack::~stack() {
    free(this->zone);
}

void stack::push(void *data) {
    this->pointer++;
    if (this->pointer>=this->amount) {
        printf("Out of stack\r\n");
        exit(0);
    }
    memcpy((char *)this->zone+this->pointer*this->size,data,this->size);
}

void stack::get(void *data) {
	this->pop(data);
	this->pointer++;
}

int stack::count() {
	return (this->pointer+1);
}

void stack::dec() {
    if (this->pointer>=0) {
		this->pointer--;
	}
}

void stack::pop(void *data) {
    if (this->pointer>=0) {
	    memcpy(data,(char *)this->zone+(this->pointer--)*this->size,this->size);
    } else {
        printf("Stack pop error\r\n");
        exit(0);
	}
}

void stack::reset() {
	this->pointer=-1;
}

void stack::next(void *data,int *counter) {
	if ((*counter)<=this->amount) {
		memcpy(data,(char *)this->zone+((*counter)++)*this->size,this->size);
	}
}
